;	This sample uses a 4MHz crystal.
;
;
	list p=16f1827           ;processor = 16f1827
	include "p16f1827.inc"   ;include standard header file
;
;
 	__CONFIG _CONFIG1, _FOSC_XT & _WDTE_OFF & _PWRTE_ON & _MCLRE_ON & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF
;
;
	CBLOCK 0x70 ; Define GPR variable register locations
		TEMP
		TEMP2
		TEMP3
	ENDC
;
;
;
;       #####start of program#####
;
	org	H'0000'		;reset vector
	clrwdt
	goto    setup
	org	H'0004'
	goto	rs_232_int	;interupt vector
setup
	;
	;bankselOSCCON
	;movlw	B'01101000'
	;movwf	OSCCON		;change to 4MHz internal osc speed
	;
	banksel	PORTA
	clrf    PORTA
	clrf    PORTB
	;
	banksel	ANSELA
	movlw	B'00000000'	;make all port A digital
	movwf	ANSELA
	movlw	B'00000000'	;make B digital
	movwf	ANSELB
	;
	banksel	TRISA
	movlw	B'00000000'
	movwf	TRISA
	movlw	B'00000110'	;B0 & B3 are inputs, usart output self configures
	movwf	TRISB
	;
	banksel	SPBRGL
	movlw	D'51'		;4K8 Baud
	movwf	SPBRGL
	clrf	SPBRGH
	bcf	TXSTA,SYNC	;not synchronous mode
	bsf	TXSTA,BRGH	;high speed baud generator
	bsf	RCSTA,SPEN	;enable async. serial port
	bsf	TXSTA,TXEN	;enable USART TX
	bsf	RCSTA,CREN	;enable USART RX
	banksel	PORTA
	;
	bsf     INTCON,GIE	;enable global interupts
	bsf     INTCON,PEIE	;enable periferal interupts
	banksel	PIE1
	bsf	PIE1,RCIE	;enable TMR1 interupts
	banksel	PORTA
	;
	call	rx_responce	;test TX on power-up
start
	clrwdt
	goto	start

;
;	######interupt######
;
rs_232_int
	banksel	RCSTA
	btfsc	RCSTA,OERR	;check for error, if found reset port
	goto	reset_port
	;
	movf	RCREG,W
	movwf	TEMP
	;movwf	TXREG		;loads the byte when buffer ready
	banksel	PORTA
	call	rx_responce
	
finish
	banksel	PORTA
	retfie			;returns from interupt, GIE set
	;
	;
reset_port
	bcf	RCSTA,CREN
	bsf	RCSTA,CREN
	goto	finish
;
;	#####rs232_out routine follows#####
;
rs232_out
	btfss	PIR1,TXIF
	goto	$-1
	banksel	TXREG
	movwf	TXREG		;loads the byte when buffer ready
	banksel	PORTA
	return
;
;	#####config mode banner routine follows#####
;
rx_responce
	movlw	'R'
	call	rs232_out
	movlw	'X'
	call	rs232_out
	movlw	H'0D'		;carriage return
	call	rs232_out
	movlw	H'0A'
	call	rs232_out	;line feed
	return
	;
	END